Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 4292)
@@ -237,150 +964,236 @@
             !
             ii0 = 160   ;   ii1 = 160        ! Bab el Mandeb (e2u and e1v were modified)
-            ij0 =  88   ;   ij1 =  88   
-            DO jk = 1, jpkm1                 ! set the before scale factors at u-points
+            ij0 =  88   ;   ij1 =  88
+            DO jk = 1, jpkm1
                DO jj = mj0(ij0), mj1(ij1)
                   DO ji = mi0(ii0), mi1(ii1)
-                     zvt = fse3t_b(ji,jj,jk) * e1t(ji,jj)
-                     pe3u_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji+1,jj,jk) * e1t(ji+1,jj) ) / ( e1u(ji,jj) )
+                     SELECT CASE ( pout )
+                     CASE( 'U' )
+                        pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk)                                        &
+                       &                    * (   e1t(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3t_0(ji  ,jj,jk) ) &
+                       &                    +     e1t(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3t_0(ji+1,jj,jk) ) &
+                       &                      ) / e1u(ji,jj)   +   e3u_0(ji,jj,jk)
+                     CASE( 'V' )
+                        pe3_out(ji,jj,jk) = 0.5_wp * vmask(ji,jj,jk)                                        &
+                       &                    * (   e2t(ji,jj  ) * ( pe3_in(ji,jj  ,jk) - e3t_0(ji,jj  ,jk) ) &
+                       &                    +     e2t(ji,jj+1) * ( pe3_in(ji,jj+1,jk) - e3t_0(ji,jj+1,jk) ) &
+                       &                      ) / e2v(ji,jj)   +   e3v_0(ji,jj,jk)
+                     CASE( 'F' )
+                        pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk) * umask(ji,jj+1,jk)                    &
+                       &                    * (   e1u(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3u_0(ji  ,jj,jk) ) &
+                       &                    +     e1u(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3u_0(ji+1,jj,jk) ) &
+                       &                      ) / e1f(ji,jj)   +   e3f_0(ji,jj,jk)
+                     END SELECT
                   END DO
                END DO
             END DO
-            DO jk = 1, jpkm1                 ! set the before scale factors at v-points
-               DO jj = mj0(ij0), mj1(ij1)
-                  DO ji = mi0(ii0), mi1(ii1)
-                     zvt = fse3t_b(ji,jj,jk) * e2t(ji,jj)
-                     pe3v_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji,jj+1,jk) * e2t(ji,jj+1) ) / ( e2v(ji,jj) )
-                  END DO
-               END DO
-            END DO
          ENDIF
 
          ii0 = 145   ;   ii1 = 146        ! Danish Straits (e2u was modified)
-         ij0 = 116   ;   ij1 = 116   
-         DO jk = 1, jpkm1                 ! set the before scale factors at u-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e1t(ji,jj)
-                  pe3u_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji+1,jj,jk) * e1t(ji+1,jj) ) / ( e1u(ji,jj) )
-               END DO
-            END DO
-         END DO
-         !
+         ij0 = 116   ;   ij1 = 116
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'U' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk)                                        &
+                    &                    * (   e1t(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3t_0(ji  ,jj,jk) ) &
+                    &                    +     e1t(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3t_0(ji+1,jj,jk) ) &
+                    &                      ) / e1u(ji,jj)   +   e3u_0(ji,jj,jk)
+                  CASE( 'F' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk) * umask(ji,jj+1,jk)                    &
+                    &                    * (   e1u(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3u_0(ji  ,jj,jk) ) &
+                    &                    +     e1u(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3u_0(ji+1,jj,jk) ) &
+                    &                      ) / e1f(ji,jj)   +   e3f_0(ji,jj,jk)
+                  END SELECT
+               END DO
+            END DO
+         END DO
       ENDIF
+      !
          !                                             ! =====================
       IF( cp_cfg == "orca" .AND. jp_cfg == 1 ) THEN    ! ORCA R1 configuration
          !                                             ! =====================
-
+         !
          ii0 = 281   ;   ii1 = 282        ! Gibraltar Strait (e2u was modified)
-         ij0 = 200   ;   ij1 = 200   
-         DO jk = 1, jpkm1                 ! set the before scale factors at u-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e1t(ji,jj)
-                  pe3u_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji+1,jj,jk) * e1t(ji+1,jj) ) / ( e1u(ji,jj) )
-               END DO
-            END DO
-         END DO
-
+         ij0 = 200   ;   ij1 = 200
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'U' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk)                                        &
+                    &                    * (   e1t(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3t_0(ji  ,jj,jk) ) &
+                    &                    +     e1t(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3t_0(ji+1,jj,jk) ) &
+                    &                      ) / e1u(ji,jj)   +   e3u_0(ji,jj,jk)
+                  CASE( 'F' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk) * umask(ji,jj+1,jk)                    &
+                    &                    * (   e1u(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3u_0(ji  ,jj,jk) ) &
+                    &                    +     e1u(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3u_0(ji+1,jj,jk) ) &
+                    &                      ) / e1f(ji,jj)   +   e3f_0(ji,jj,jk)
+                  END SELECT
+               END DO
+            END DO
+         END DO
+         !
          ii0 = 314   ;   ii1 = 315        ! Bhosporus Strait (e2u was modified)
-         ij0 = 208   ;   ij1 = 208   
-         DO jk = 1, jpkm1                 ! set the before scale factors at u-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e1t(ji,jj)
-                  pe3u_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji+1,jj,jk) * e1t(ji+1,jj) ) / ( e1u(ji,jj) )
-               END DO
-            END DO
-         END DO
-
+         ij0 = 208   ;   ij1 = 208
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'U' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk)                                        &  
+                    &                    * (   e1t(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3t_0(ji  ,jj,jk) ) &
+                    &                    +     e1t(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3t_0(ji+1,jj,jk) ) &
+                    &                      ) / e1u(ji,jj)   +   e3u_0(ji,jj,jk)
+                  CASE( 'F' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk) * umask(ji,jj+1,jk)                    &  
+                    &                    * (   e1u(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3u_0(ji  ,jj,jk) ) &
+                    &                    +     e1u(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3u_0(ji+1,jj,jk) ) &
+                    &                      ) / e1f(ji,jj)   +   e3f_0(ji,jj,jk)
+                  END SELECT
+               END DO
+            END DO
+         END DO
+         !
          ii0 =  44   ;   ii1 =  44        ! Lombok Strait (e1v was modified)
-         ij0 = 124   ;   ij1 = 125   
-         DO jk = 1, jpkm1                 ! set the before scale factors at v-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e2t(ji,jj)
-                  pe3v_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji,jj+1,jk) * e2t(ji,jj+1) ) / ( e2v(ji,jj) )
-               END DO
-            END DO
-         END DO
-
+         ij0 = 124   ;   ij1 = 125
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'V' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * vmask(ji,jj,jk)                                        &
+                    &                    * (   e2t(ji,jj  ) * ( pe3_in(ji,jj  ,jk) - e3t_0(ji,jj  ,jk) ) &
+                    &                    +     e2t(ji,jj+1) * ( pe3_in(ji,jj+1,jk) - e3t_0(ji,jj+1,jk) ) &
+                    &                      ) / e2v(ji,jj)   +   e3v_0(ji,jj,jk)
+                  END SELECT
+               END DO
+            END DO
+         END DO
+         !
          ii0 =  48   ;   ii1 =  48        ! Sumba Strait (e1v was modified) [closed from bathy_11 on]
-         ij0 = 124   ;   ij1 = 125   
-         DO jk = 1, jpkm1                 ! set the before scale factors at v-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e2t(ji,jj)
-                  pe3v_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji,jj+1,jk) * e2t(ji,jj+1) ) / ( e2v(ji,jj) )
-               END DO
-            END DO
-         END DO
-
+         ij0 = 124   ;   ij1 = 125
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'V' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * vmask(ji,jj,jk)                                        &
+                    &                    * (   e2t(ji,jj  ) * ( pe3_in(ji,jj  ,jk) - e3t_0(ji,jj  ,jk) ) &
+                    &                    +     e2t(ji,jj+1) * ( pe3_in(ji,jj+1,jk) - e3t_0(ji,jj+1,jk) ) &
+                    &                      ) / e2v(ji,jj)   +   e3v_0(ji,jj,jk)
+                  END SELECT
+               END DO
+            END DO
+         END DO
+         !
          ii0 =  53   ;   ii1 =  53        ! Ombai Strait (e1v was modified)
-         ij0 = 124   ;   ij1 = 125   
-         DO jk = 1, jpkm1                 ! set the before scale factors at v-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e2t(ji,jj)
-                  pe3v_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji,jj+1,jk) * e2t(ji,jj+1) ) / ( e2v(ji,jj) )
-               END DO
-            END DO
-         END DO
-
+         ij0 = 124   ;   ij1 = 125
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'V' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * vmask(ji,jj,jk)                                        &
+                    &                    * (   e2t(ji,jj  ) * ( pe3_in(ji,jj  ,jk) - e3t_0(ji,jj  ,jk) ) &
+                    &                    +     e2t(ji,jj+1) * ( pe3_in(ji,jj+1,jk) - e3t_0(ji,jj+1,jk) ) &
+                    &                      ) / e2v(ji,jj)   +   e3v_0(ji,jj,jk)
+                  END SELECT
+               END DO
+            END DO
+         END DO
+         !
          ii0 =  56   ;   ii1 =  56        ! Timor Passage (e1v was modified)
-         ij0 = 124   ;   ij1 = 125   
-         DO jk = 1, jpkm1                 ! set the before scale factors at v-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e2t(ji,jj)
-                  pe3v_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji,jj+1,jk) * e2t(ji,jj+1) ) / ( e2v(ji,jj) )
-               END DO
-            END DO
-         END DO
-
+         ij0 = 124   ;   ij1 = 125
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'V' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * vmask(ji,jj,jk)                                        &
+                    &                    * (   e2t(ji,jj  ) * ( pe3_in(ji,jj  ,jk) - e3t_0(ji,jj  ,jk) ) &
+                    &                    +     e2t(ji,jj+1) * ( pe3_in(ji,jj+1,jk) - e3t_0(ji,jj+1,jk) ) &
+                    &                      ) / e2v(ji,jj)   +   e3v_0(ji,jj,jk)
+                  END SELECT
+               END DO
+            END DO
+         END DO
+         !
          ii0 =  55   ;   ii1 =  55        ! West Halmahera Strait (e1v was modified)
-         ij0 = 141   ;   ij1 = 142   
-         DO jk = 1, jpkm1                 ! set the before scale factors at v-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e2t(ji,jj)
-                  pe3v_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji,jj+1,jk) * e2t(ji,jj+1) ) / ( e2v(ji,jj) )
-               END DO
-            END DO
-         END DO
-
+         ij0 = 141   ;   ij1 = 142
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'V' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * vmask(ji,jj,jk)                                        &
+                    &                    * (   e2t(ji,jj  ) * ( pe3_in(ji,jj  ,jk) - e3t_0(ji,jj  ,jk) ) &
+                    &                    +     e2t(ji,jj+1) * ( pe3_in(ji,jj+1,jk) - e3t_0(ji,jj+1,jk) ) &
+                    &                      ) / e2v(ji,jj)   +   e3v_0(ji,jj,jk)
+                  END SELECT
+               END DO
+            END DO
+         END DO
+         !
          ii0 =  58   ;   ii1 =  58        ! East Halmahera Strait (e1v was modified)
-         ij0 = 141   ;   ij1 = 142   
-         DO jk = 1, jpkm1                 ! set the before scale factors at v-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e2t(ji,jj)
-                  pe3v_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji,jj+1,jk) * e2t(ji,jj+1) ) / ( e2v(ji,jj) )
-               END DO
-            END DO
-         END DO
-
-         !
+         ij0 = 141   ;   ij1 = 142
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'V' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * vmask(ji,jj,jk)                                        &
+                    &                    * (   e2t(ji,jj  ) * ( pe3_in(ji,jj  ,jk) - e3t_0(ji,jj  ,jk) ) &
+                    &                    +     e2t(ji,jj+1) * ( pe3_in(ji,jj+1,jk) - e3t_0(ji,jj+1,jk) ) &
+                    &                      ) / e2v(ji,jj)   +   e3v_0(ji,jj,jk)
+                  END SELECT
+               END DO
+            END DO
+         END DO
       ENDIF
-      !                                                ! ======================
+         !                                             ! =====================
       IF( cp_cfg == "orca" .AND. jp_cfg == 05 ) THEN   ! ORCA R05 configuration
-         !                                             ! ======================
+         !                                             ! =====================
+         !
          ii0 = 563   ;   ii1 = 564        ! Gibraltar Strait (e2u was modified)
-         ij0 = 327   ;   ij1 = 327   
-         DO jk = 1, jpkm1                 ! set the before scale factors at u-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e1t(ji,jj)
-                  pe3u_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji+1,jj,jk) * e1t(ji+1,jj) ) / ( e1u(ji,jj) )
-               END DO
-            END DO
-         END DO
-         !
-         ii0 = 627   ;   ii1 = 628        ! Bosphore Strait (e2u was modified)
-         ij0 = 343   ;   ij1 = 343   
-         DO jk = 1, jpkm1                 ! set the before scale factors at u-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e1t(ji,jj)
-                  pe3u_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji+1,jj,jk) * e1t(ji+1,jj) ) / ( e1u(ji,jj) )
+         ij0 = 327   ;   ij1 = 327
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'U' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk)                                        &
+                    &                    * (   e1t(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3t_0(ji  ,jj,jk) ) &
+                    &                    +     e1t(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3t_0(ji+1,jj,jk) ) &
+                    &                      ) / e1u(ji,jj)   +   e3u_0(ji,jj,jk)
+                  CASE( 'F' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk) * umask(ji,jj+1,jk)                    &
+                    &                    * (   e1u(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3u_0(ji  ,jj,jk) ) &
+                    &                    +     e1u(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3u_0(ji+1,jj,jk) ) &
+                    &                      ) / e1f(ji,jj)   +   e3f_0(ji,jj,jk)
+                  END SELECT
+               END DO
+            END DO
+         END DO
+         !
+         ii0 = 627   ;   ii1 = 628        ! Bosphorus Strait (e2u was modified)
+         ij0 = 343   ;   ij1 = 343
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'U' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk)                                        &  
+                    &                    * (   e1t(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3t_0(ji  ,jj,jk) ) &
+                    &                    +     e1t(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3t_0(ji+1,jj,jk) ) &
+                    &                      ) / e1u(ji,jj)   +   e3u_0(ji,jj,jk)
+                  CASE( 'F' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk) * umask(ji,jj+1,jk)                    &  
+                    &                    * (   e1u(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3u_0(ji  ,jj,jk) ) &
+                    &                    +     e1u(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3u_0(ji+1,jj,jk) ) &
+                    &                      ) / e1f(ji,jj)   +   e3f_0(ji,jj,jk)
+                  END SELECT
                END DO
             END DO
@@ -388,10 +1201,20 @@
          !
          ii0 =  93   ;   ii1 =  94        ! Sumba Strait (e2u was modified)
-         ij0 = 232   ;   ij1 = 232   
-         DO jk = 1, jpkm1                 ! set the before scale factors at u-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e1t(ji,jj)
-                  pe3u_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji+1,jj,jk) * e1t(ji+1,jj) ) / ( e1u(ji,jj) )
+         ij0 = 232   ;   ij1 = 232
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'U' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk)                                        &
+                    &                    * (   e1t(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3t_0(ji  ,jj,jk) ) &
+                    &                    +     e1t(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3t_0(ji+1,jj,jk) ) &
+                    &                      ) / e1u(ji,jj)   +   e3u_0(ji,jj,jk)
+                  CASE( 'F' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk) * umask(ji,jj+1,jk)                    &
+                    &                    * (   e1u(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3u_0(ji  ,jj,jk) ) &
+                    &                    +     e1u(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3u_0(ji+1,jj,jk) ) &
+                    &                      ) / e1f(ji,jj)   +   e3f_0(ji,jj,jk)
+                  END SELECT
                END DO
             END DO
@@ -399,10 +1222,20 @@
          !
          ii0 = 103   ;   ii1 = 103        ! Ombai Strait (e2u was modified)
-         ij0 = 232   ;   ij1 = 232   
-         DO jk = 1, jpkm1                 ! set the before scale factors at u-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e1t(ji,jj)
-                  pe3u_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji+1,jj,jk) * e1t(ji+1,jj) ) / ( e1u(ji,jj) )
+         ij0 = 232   ;   ij1 = 232
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'U' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk)                                        &
+                    &                    * (   e1t(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3t_0(ji  ,jj,jk) ) &
+                    &                    +     e1t(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3t_0(ji+1,jj,jk) ) &
+                    &                      ) / e1u(ji,jj)   +   e3u_0(ji,jj,jk)
+                  CASE( 'F' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk) * umask(ji,jj+1,jk)                    &
+                    &                    * (   e1u(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3u_0(ji  ,jj,jk) ) &
+                    &                    +     e1u(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3u_0(ji+1,jj,jk) ) &
+                    &                      ) / e1f(ji,jj)   +   e3f_0(ji,jj,jk)
+                  END SELECT
                END DO
             END DO
@@ -410,10 +1243,20 @@
          !
          ii0 =  15   ;   ii1 =  15        ! Palk Strait (e2u was modified)
-         ij0 = 270   ;   ij1 = 270   
-         DO jk = 1, jpkm1                 ! set the before scale factors at u-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e1t(ji,jj)
-                  pe3u_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji+1,jj,jk) * e1t(ji+1,jj) ) / ( e1u(ji,jj) )
+         ij0 = 270   ;   ij1 = 270
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'U' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk)                                        &
+                    &                    * (   e1t(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3t_0(ji  ,jj,jk) ) &
+                    &                    +     e1t(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3t_0(ji+1,jj,jk) ) &
+                    &                      ) / e1u(ji,jj)   +   e3u_0(ji,jj,jk)
+                  CASE( 'F' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk) * umask(ji,jj+1,jk)                    &
+                    &                    * (   e1u(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3u_0(ji  ,jj,jk) ) &
+                    &                    +     e1u(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3u_0(ji+1,jj,jk) ) &
+                    &                      ) / e1f(ji,jj)   +   e3f_0(ji,jj,jk)
+                  END SELECT
                END DO
             END DO
@@ -421,10 +1264,15 @@
          !
          ii0 =  87   ;   ii1 =  87        ! Lombok Strait (e1v was modified)
-         ij0 = 232   ;   ij1 = 233   
-         DO jk = 1, jpkm1                 ! set the before scale factors at v-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e2t(ji,jj)
-                  pe3v_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji,jj+1,jk) * e2t(ji,jj+1) ) / ( e2v(ji,jj) )
+         ij0 = 232   ;   ij1 = 233
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'V' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * vmask(ji,jj,jk)                                        &
+                    &                    * (   e2t(ji,jj  ) * ( pe3_in(ji,jj  ,jk) - e3t_0(ji,jj  ,jk) ) &
+                    &                    +     e2t(ji,jj+1) * ( pe3_in(ji,jj+1,jk) - e3t_0(ji,jj+1,jk) ) &
+                    &                      ) / e2v(ji,jj)   +   e3v_0(ji,jj,jk)
+                  END SELECT
                END DO
             END DO
@@ -432,52 +1280,20 @@
          !
          ii0 = 662   ;   ii1 = 662        ! Bab el Mandeb (e1v was modified)
-         ij0 = 276   ;   ij1 = 276   
-         DO jk = 1, jpkm1                 ! set the before scale factors at v-points
-            DO jj = mj0(ij0), mj1(ij1)
-               DO ji = mi0(ii0), mi1(ii1)
-                  zvt = fse3t_b(ji,jj,jk) * e2t(ji,jj)
-                  pe3v_b(ji,jj,jk) = 0.5_wp * ( zvt + fse3t_b(ji,jj+1,jk) * e2t(ji,jj+1) ) / ( e2v(ji,jj) )
-               END DO
-            END DO
-         END DO
-         !
+         ij0 = 276   ;   ij1 = 276
+         DO jk = 1, jpkm1
+            DO jj = mj0(ij0), mj1(ij1)
+               DO ji = mi0(ii0), mi1(ii1)
+                  SELECT CASE ( pout )
+                  CASE( 'V' )
+                     pe3_out(ji,jj,jk) = 0.5_wp * vmask(ji,jj,jk)                                        &
+                    &                    * (   e2t(ji,jj  ) * ( pe3_in(ji,jj  ,jk) - e3t_0(ji,jj  ,jk) ) &
+                    &                    +     e2t(ji,jj+1) * ( pe3_in(ji,jj+1,jk) - e3t_0(ji,jj+1,jk) ) &
+                    &                      ) / e2v(ji,jj)   +   e3v_0(ji,jj,jk)
+                  END SELECT
+               END DO
+            END DO
+         END DO
       ENDIF
-      ! End of individual corrections to scale factors
-
-      IF( ln_zps ) THEN          ! minimum of the e3t at partial cell level
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1
-               iku = mbku(ji,jj)
-               ikv = mbkv(ji,jj)
-               pe3u_b(ji,jj,iku) = MIN( fse3t_b(ji,jj,iku), fse3t_b(ji+1,jj  ,iku) ) 
-               pe3v_b(ji,jj,ikv) = MIN( fse3t_b(ji,jj,ikv), fse3t_b(ji  ,jj+1,ikv) ) 
-            END DO
-         END DO
-      ENDIF
-
-      pe3u_b(:,:,:) = pe3u_b(:,:,:) - fse3u_0(:,:,:)      ! anomaly to avoid zero along closed boundary/extra halos
-      pe3v_b(:,:,:) = pe3v_b(:,:,:) - fse3v_0(:,:,:)
-      CALL lbc_lnk( pe3u_b(:,:,:), 'U', 1. )               ! lateral boundary conditions
-      CALL lbc_lnk( pe3v_b(:,:,:), 'V', 1. )
-      pe3u_b(:,:,:) = pe3u_b(:,:,:) + fse3u_0(:,:,:)      ! recover the full scale factor
-      pe3v_b(:,:,:) = pe3v_b(:,:,:) + fse3v_0(:,:,:)
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('dom_vvl_2')
-      !
-   END SUBROUTINE dom_vvl_2
-   
-#else
-   !!----------------------------------------------------------------------
-   !!   Default option :                                      Empty routine
-   !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE dom_vvl
-   END SUBROUTINE dom_vvl
-   SUBROUTINE dom_vvl_2(kdum, pudum, pvdum )
-      USE par_kind
-      INTEGER                   , INTENT(in   ) ::   kdum       
-      REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   pudum, pvdum
-   END SUBROUTINE dom_vvl_2
-#endif
+   END SUBROUTINE dom_vvl_orca_fix
 
    !!======================================================================
